AWSTemplateFormatVersion: '2010-09-09'
Description: Create a stak

Parameters:
  BucketName:
    Type: String
    Default: unique-bucket-name-unique-across-world

Resources:
  Bucket:
    Type: AWS::S3::Bucket
    Properties: 
      BucketName: !Ref BucketName
      Tags:
      - Key: Name
        Value:  !Join ['', [!Ref "AWS::StackName", "-VPC" ]]
      NotificationConfiguration:
        LambdaConfigurations:
          - Event: 's3:ObjectCreated:*'
          #Filter:
           # S3Key:
            #  Rules:
             #   - Name: prefix
              #    Value: test/
               # - Name: suffix
                #  Value: .txt
            Function: !GetAtt Lambda.Arn  
  Lambda:
    Type: AWS::Lambda::Function
    Properties:
      Code: 
        ZipFile: > # Copied the code from 
          import json
          import boto3
          s3_client=boto3.client('s3')
          # lambda function to copy file from 1 s3 to another s3
          def lambda_handler(event, context):
              #specify source bucket
              source_bucket_name=event['Records'][0]['s3']['bucket']['name']
              #get object that has been uploaded
              file_name=event['Records'][0]['s3']['object']['key']
              #specify destination bucket
              destination_bucket_name='mys3buckettoopens3'
              #specify from where file needs to be copied
              copy_object={'Bucket':source_bucket_name,'Key':file_name}
              #write copy statement 
              s3_client.copy_object(CopySource=copy_object,Bucket=destination_bucket_name,Key=file_name)
              return {
                  'statusCode': 3000,
                  'body': json.dumps('File has been Successfully Copied')
              }
      Role: arn:aws:iam::938536244682:role/ProvideS3FullAccess
      Runtime: python3.9
      Handler: somelambdafunction # Method Name
      FunctionName: somelambdafunctionname #Function Name
  S3InvokeLambdaPermission:
    Type: AWS::Lambda::Permission
    Properties:
      Action: lambda:InvokeFunction
      FunctionName: !Ref Lambda
      Principal: s3.amazonaws.com
      SourceArn: !Sub arn:aws:s3:::${BucketName}

  LambdaRole:
    Type: AWS::IAM::Role
    Description: i have added it to test MF
    Properties:
      AssumeRolePolicyDocument:
        Version: '2012-10-17'
        Statement:
        - Effect: Allow
          Principal:
            Service: lambda.amazonaws.com
          Action:
          - sts:AssumeRole
      Path: '/'
      Policies:
      - PolicyName: s3
        PolicyDocument:
          Statement:
          - Effect: Allow
            Action:
              - s3:Get*
            Resource:
              - !Sub arn:aws:s3:::${BucketName}
              - !Sub arn:aws:s3:::${BucketName}/*